Application Specification YML
=============================

.. note:: All specification files must end in `.yml`, *not* `.yaml`
   (with the extra `a`). The :doc:`io` expects linked specification
   files to have the extension `.yml`.

When `datacustodian` starts, it is provided with a list of
application-level specification files. Each application runs on its
own port, using its own application server. To configure the server
and application, the following sections are required:

1. server
2. app
3. package
4. components

Each is described in its own section below, followed by an example
file used for unit testing.

`server` YML Specification
--------------------------

The `server` tag provides application settings to the
:class:`flask.Flask` server. `datacustodian` uses
:mod:`flask_restplus` to auto-generate swagger documentation for the
APIs, and to enable a cleaner specification document for
auto-generating packages. We recommend looking at the configuration
options for :class:`flask.Flask` for additional details.

.. code-block:: yaml

   server:
     SERVER_NAME: localhost:8888
     SWAGGER_UI_DOC_EXPANSION: 'list'
     RESTPLUS_VALIDATE: True
     RESTPLUS_MASK_SWAGGER: False
     ERROR_404_HELP: False

`app` YML Specification
-----------------------

The `app` section provides a name and description for the app that
show up in metadata on the application server. It also sets whether
the application is running in `debug` mode or not.

.. code-block:: yaml

   app:
     title: "UGS Record Keeper API"
     description: "REST API access to record keeper records, consent, etc."
     debug: False		

`package` YML Specification
---------------------------

The `package` section describes the package that will be
auto-generated by `datacustodian`. In addition to a name, description,
and version (which are self-explanatory), the specification also
includes a `root` directory, which is the repository root for the
generated package.

Since the auto-generated package is a python-based package, the
specified `root` folder will have `setup.py`, `tests`, a folder with
the name of the package, and a `__init__.py` file to set it up as a
package. The :doc:`writers` will then generate a module file for each
of the *components*, which are described below. Additionally,
:doc:`writers` will also create a `test_component.py` file with a
skeleton structure for testing every endpoint and method defined in
the namespaces of each component. These test files are placed in the
`tests` folder.

Finally, a `conftest.py` is also generated in the `tests` folder that
creates a client for running the unit tests as a session-based fixture
in `pytest`.

.. code-block:: yaml

   package:
     name: ugs
     root: ~/ugs-dist
     version: 0.0.1
     description: Record management REST API dynamically generated package.		

`components` YML Specification
------------------------------

The `components` section ultimately defines the REST API endpoints
that will be served by the auto-generated package. It provides a list
of components, each of which will have its own module in the
auto-generated package. These auto-generated modules define
namespaces that provide endpoints with support for all the common HTTP
methods.

The attributes defined for each component are:

1. **name**: this should be a lower-case name that matches python's
   naming conventions for *modules*.
2. **models**: a list of model specifications. Models define the data
   structures for requests and responses. If a model is defined, the
   api will automatically validate requests and marshal
   responses. Models are discussed in their own :doc:`models`.
3. **parsers**: when requests have multiple parameters, some of which
   are optional, and some of which may have a limited number of
   valid choices, etc. a parser can be constructed (similar to the way
   `argparse` works for CLI) that automatically validates
   requests. Parsers are discussed in their own :doc:`parsers`.
4. **namespaces**: define the actual endpoints and HTTP methods that
   the application will support. Namespaces are discussed in their own
   :doc:`namespaces`.
5. **url_prefix**: the root folder in the URL that requests will be
   directed to.
6. **title**: for the auto-generated swagger documentation, what is
   the title of this component.
7. **description**: as for `title`, this just shows up in the swagger
   documentation and `docstring` of the generated module.

Since the specifications for `parsers`, `models`, and `namespaces` can
be rather long and involved, `datacustodian` provides a :doc:`io` to
allow convenient linking of additional YML files in the context of the
link. This is demonstrated in the example below:

.. code-block:: yaml

   components:
     - name: records
       models: ':record-models'
       namespaces: ':record-namespaces'
       parsers: ':record-parsers'
       url_prefix: '/records'
       title: "Data Custodian Records API"
       description: "REST API access to data keeper records."

Note that the value for `models` starts with a `:`. This specifies
that the value is actually another YML file. The path is relative
after the `:` so that if the file was in another folder (for example
`global` at the same level as this specification file), we could just
use:

.. code-block:: yaml

   models: ':../global/global-model'

Note also that these links do *not* use a `.yml` extension, that is
assumed.

Complete Example
----------------

Look at the full example used for the unit tests at :download:`records.yml <configs/records.yml>`.
